from geniusweb.issuevalue.NumberValue import NumberValue
from geniusweb.issuevalue.ValueSet import ValueSet
from immutablelist.Range import Range


class NumberValueSet ( ValueSet ):

	def __init__(self,  range:Range ):
		self._range = range;

	def getRange(self)->Range :
		'''	 
		@return the range defining this NumberValueSet.
		'''
		return self._range

	def get(self, index:int) -> NumberValue :
		return NumberValue(self._range.get(index))
	
	def size(self) -> int:
		return self._range.size()
	
	def __iter__(self):
		raise NotImplemented

	def __str__(self) -> str :
		return "NumberValueSet[" + str(self._range.getLow()) + "," +\
			 str(self._range.getHigh()) + "," + str(self._range.getStep()) + "]"

	def __eq__(self, other):
		return isinstance(other, self.__class__) and \
			 self._range == other._range

